Index: XIOS/trunk/src/client_server_mapping_distributed.cpp
===================================================================
--- XIOS/trunk/src/client_server_mapping_distributed.cpp	(revision 623)
+++ XIOS/trunk/src/client_server_mapping_distributed.cpp	(revision 624)
@@ -35,5 +35,4 @@
    Compute mapping global index of server which client sends to.
    \param [in] globalIndexOnClient global index client has
-   \param [in] localIndexOnClient local index on client
 */
 void CClientServerMappingDistributed::computeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient)
@@ -61,10 +60,4 @@
       int indexClient = std::distance(itbClientHash, itClientHash)-1;
 
-      if (clientRank_ == indexClient)
-      {
-        (indexGlobalOnServer_[globalIndexToServerMapping_[globalIndexClient]]).push_back(globalIndexClient);
-        ++nbIndexAlreadyOnClient;
-      }
-      else
       {
         client2ClientIndexGlobal[indexClient].push_back(globalIndexClient);
@@ -88,11 +81,15 @@
 
   int nbDemandingClient = recvBuff[clientRank_], nbIndexServerReceived = 0;
+
   // Receiving demand as well as the responds from other clients
   // The demand message contains global index; meanwhile the responds have server index information
   // Buffer to receive demand from other clients, it can be allocated or not depending whether it has demand(s)
   unsigned long* recvBuffIndexGlobal = 0;
-  int maxNbIndexDemandedFromOthers = (nbIndexAlreadyOnClient >= globalIndexToServerMapping_.size())
-                                   ? 0 : (globalIndexToServerMapping_.size() - nbIndexAlreadyOnClient);
-  if (!isDataDistributed_) maxNbIndexDemandedFromOthers = nbDemandingClient * globalIndexToServerMapping_.size(); // Not very optimal but it's general
+//  int maxNbIndexDemandedFromOthers = (nbIndexAlreadyOnClient >= globalIndexToServerMapping_.size())
+//                                   ? 0 : (globalIndexToServerMapping_.size() - nbIndexAlreadyOnClient);
+  int maxNbIndexDemandedFromOthers = (globalIndexToServerMapping_.size() > nbIndexSendToOthers)
+                                      ? globalIndexToServerMapping_.size() : nbIndexSendToOthers;
+
+  if (!isDataDistributed_) maxNbIndexDemandedFromOthers = nbDemandingClient * nbIndexSendToOthers; //globalIndexToServerMapping_.size(); // Not very optimal but it's general
 
   if (0 != maxNbIndexDemandedFromOthers)
@@ -102,5 +99,4 @@
   int* recvBuffIndexServer = 0;
   int nbIndexReceivedFromOthers = nbIndexSendToOthers;
-//  int nbIndexReceivedFromOthers = globalIndexToServerMapping_.size() - nbIndexAlreadyOnClient;
   if (0 != nbIndexReceivedFromOthers)
     recvBuffIndexServer = new int[nbIndexReceivedFromOthers];
@@ -237,9 +233,4 @@
     {
       int indexClient = std::distance(itbClientHash, itClientHash)-1;
-      if (clientRank_ == indexClient)
-      {
-        globalIndexToServerMapping_.insert(std::make_pair<size_t,int>(it->first, it->second));
-      }
-      else
       {
         sendBuff[indexClient] = 1;
Index: XIOS/trunk/src/distribution_client.cpp
===================================================================
--- XIOS/trunk/src/distribution_client.cpp	(revision 623)
+++ XIOS/trunk/src/distribution_client.cpp	(revision 624)
@@ -148,5 +148,4 @@
     axisMasks_[i].resize(axisList[i]->mask.numElements());
     axisMasks_[i] = axisList[i]->mask;
-    std::cout << "axisMask " << axisMasks_[i] << std::endl;
   }
 
@@ -201,6 +200,6 @@
       nBeginLocal_.at(indexMap_[idx]+1) = 0;
       nBeginGlobal_.at(indexMap_[idx]+1) = domList[domIndex]->jbegin;
-//      nZoomBegin_.at((indexMap_[idx]+1)) = domList[domIndex]->zoom_jbegin;
-//      nZoomEnd_.at((indexMap_[idx]+1))   = domList[domIndex]->zoom_jbegin + domList[domIndex]->zoom_nj-1;
+      nZoomBegin_.at((indexMap_[idx]+1)) = domList[domIndex]->zoom_jbegin;
+      nZoomEnd_.at((indexMap_[idx]+1))   = domList[domIndex]->zoom_jbegin + domList[domIndex]->zoom_nj-1;
 
       dataBegin_.at(indexMap_[idx]+1) = (2 == domList[domIndex]->data_dim) ? domList[domIndex]->data_jbegin.getValue() : -1;
@@ -213,6 +212,6 @@
       nBeginLocal_.at(indexMap_[idx]) = 0;
       nBeginGlobal_.at(indexMap_[idx]) = domList[domIndex]->ibegin;
-//      nZoomBegin_.at((indexMap_[idx])) = domList[domIndex]->zoom_ibegin;
-//      nZoomEnd_.at((indexMap_[idx]))   = domList[domIndex]->zoom_ibegin + domList[domIndex]->zoom_ni-1;
+      nZoomBegin_.at((indexMap_[idx])) = domList[domIndex]->zoom_ibegin;
+      nZoomEnd_.at((indexMap_[idx]))   = domList[domIndex]->zoom_ibegin + domList[domIndex]->zoom_ni-1;
 
       dataBegin_.at(indexMap_[idx]) = domList[domIndex]->data_ibegin.getValue();
Index: XIOS/trunk/src/node/axis.cpp
===================================================================
--- XIOS/trunk/src/node/axis.cpp	(revision 623)
+++ XIOS/trunk/src/node/axis.cpp	(revision 624)
@@ -95,5 +95,5 @@
       }
       else this->ni.setValue(size);
-      std::cout <<  "value " <<  value <<  std::endl;
+
 //      StdSize true_size = value.numElements();
 //      if (this->ni.getValue() != true_size)
@@ -135,25 +135,25 @@
    }
 
-   void CAxis::checkZoom(void)
-   {
-      StdSize zoom_begin,zoom_end, zoom_size, axisSize;
-
-      zoom_begin = this->zoom_begin.isEmpty() ? 0 : this->zoom_begin.getValue();
-      zoom_size  = this->zoom_size.isEmpty() ? size.getValue() : this->zoom_size.getValue();
-      zoom_end   = this->zoom_end.isEmpty() ? (size.getValue() - 1) : this->zoom_end.getValue();
-
-      if (this->zoom_begin.isEmpty()) zoom_begin = zoom_end - zoom_size + 1;
-      if (this->zoom_end.isEmpty()) zoom_end = zoom_begin + zoom_size - 1;
-      if (this->zoom_size.isEmpty()) zoom_size = zoom_end - zoom_begin + 1;
-      axisSize = size.getValue();
-
-      if ( (zoom_begin < 0) || (zoom_begin > axisSize-1) || (zoom_end<0) || (zoom_end>axisSize-1) || (zoom_size<1) || (zoom_size>axisSize) || (zoom_begin>zoom_end))
-        ERROR("CAxis::checkAttributes(void)",
-              << "One or more attributes among <zoom_begin>, <zoom_end>, <zoom_size> of axis [ id = '" << getId() << "' , context = '" << CObjectFactory::GetCurrentContextId() << "' ] are not well specified");
-
-      this->zoom_begin.setValue(zoom_begin);
-      this->zoom_end.setValue(zoom_end);
-      this->zoom_size.setValue(zoom_size);
-   }
+//   void CAxis::checkZoom(void)
+//   {
+//      StdSize zoom_begin,zoom_end, zoom_size, axisSize;
+//
+//      zoom_begin = (this->zoom_begin.isEmpty()) ?  0 : this->zoom_begin.getValue() ;
+//      zoom_size  = (this->zoom_size.isEmpty()) ?  size.getValue() : this->zoom_size.getValue() ;
+//      zoom_end   = (this->zoom_end.isEmpty()) ?  (size.getValue() - 1) : this->zoom_end.getValue() ;
+//
+//      if (this->zoom_begin.isEmpty()) zoom_begin=zoom_end-zoom_size+1 ;
+//      if (this->zoom_end.isEmpty()) zoom_end=zoom_begin+zoom_size-1 ;
+//      if (this->zoom_size.isEmpty()) zoom_size=zoom_end-zoom_begin+1 ;
+//      axisSize = size.getValue();
+//
+//      if ( (zoom_begin < 0) || (zoom_begin > axisSize-1) || (zoom_end<0) || (zoom_end>axisSize-1) || (zoom_size<1) || (zoom_size>axisSize) || (zoom_begin>zoom_end))
+//        ERROR("CAxis::checkAttributes(void)",
+//              << "One or more attributes among <zoom_begin>, <zoom_end>, <zoom_size> of axis [ id = '" << getId() << "' , context = '" << CObjectFactory::GetCurrentContextId() << "' ] are not well specified");
+//
+//      this->zoom_begin.setValue(zoom_begin) ;
+//      this->zoom_end.setValue(zoom_end) ;
+//      this->zoom_size.setValue(zoom_size) ;
+//   }
 
    void CAxis::checkMask()
Index: XIOS/trunk/src/node/axis.hpp
===================================================================
--- XIOS/trunk/src/node/axis.hpp	(revision 623)
+++ XIOS/trunk/src/node/axis.hpp	(revision 624)
@@ -107,5 +107,5 @@
          void checkData();
          void checkMask();
-         void checkZoom();
+//         void checkZoom();
          void checkTransformations();
          void computeServerIndex(const std::vector<int>& globalDim, int orderPositionInGrid,
Index: XIOS/trunk/src/node/field.cpp
===================================================================
--- XIOS/trunk/src/node/field.cpp	(revision 623)
+++ XIOS/trunk/src/node/field.cpp	(revision 624)
@@ -13,6 +13,4 @@
 #include "context_server.hpp"
 #include <set>
-#include "axis_filter.hpp"
-#include "invert_algorithm.hpp"
 
 namespace xios{
@@ -29,7 +27,7 @@
       , foperation(), hasInstantData(false), hasExpression(false)
       , active(false) , hasOutputFile(false),hasFieldOut(false), slotUpdateDate(NULL)
-      , processed(false), domAxisIds_("", ""), areAllReferenceSolved(false), areAllExpressionBuilt(false), filter(0)
+      , processed(false), domAxisIds_("", ""), areAllReferenceSolved(false), areAllExpressionBuilt(false)
       , isReadDataRequestPending(false)
-      , filterSources_(), algorithms_()
+      , filterSources_()
       { setVirtualVariableGroup(); }
 
@@ -43,7 +41,7 @@
       , foperation(), hasInstantData(false), hasExpression(false)
       , active(false), hasOutputFile(false), hasFieldOut(false), slotUpdateDate(NULL)
-      , processed(false), domAxisIds_("", ""), areAllReferenceSolved(false), areAllExpressionBuilt(false), filter(0)
+      , processed(false), domAxisIds_("", ""), areAllReferenceSolved(false), areAllExpressionBuilt(false)
       , isReadDataRequestPending(false)
-      , filterSources_(), algorithms_()
+      , filterSources_()
    { setVirtualVariableGroup(); }
 
@@ -55,5 +53,4 @@
       if (hasExpression) delete expression;
       if (slotUpdateDate != NULL) delete slotUpdateDate;
-      if (0 != filter) delete filter;
 
    }
@@ -177,6 +174,4 @@
             int rank=(*it).first ;
             CArray<int,1>& index = *(it->second) ;
-                       std::cout << "rank " << index << std::endl;
-                       std::cout << "data " << data << std::endl;
             CArray<double,1> data_tmp(index.numElements()) ;
             for(int n=0;n<data_tmp.numElements();n++) data_tmp(n)=data(index(n)) ;
@@ -784,5 +779,4 @@
            fieldRef->addReference(this);
            fieldRef->solveGridDomainAxisRef(false);
-//           fieldRef->solveCheckMaskIndex(false);
            break;
          }
@@ -798,5 +792,4 @@
          fieldRef->addReference(this);
          fieldRef->solveGridDomainAxisRef(false);
-//         fieldRef->solveCheckMaskIndex(false);
        }
 
@@ -826,5 +819,5 @@
           {
              const std::map<int, CArray<int,1>* >& localIndexToSend = (*itFilterSrc)->grid->getTransformations()->getLocalIndexToSendFromGridSource();
-             const std::map<int, std::vector<CArray<int,1>* > > localIndexToReceive = (*itFilterSrc)->grid->getTransformations()->getLocalIndexToReceiveOnGridDest();
+             const std::map<int, std::vector<CArray<int,1>* > >& localIndexToReceive = (*itFilterSrc)->grid->getTransformations()->getLocalIndexToReceiveOnGridDest();
 
              sendAndReceiveTransformedData(localIndexToSend, dataToSend,
@@ -857,5 +850,4 @@
        CArray<int,1>* localIndex_p = itSend->second;
        int countSize = localIndex_p->numElements();
-       std::cout << "Data Source " <<  dataSrc <<  std::endl;
        for (int idx = 0; idx < countSize; ++idx)
        {
@@ -888,5 +880,4 @@
          }
        }
-       std::cout << "Data Destination " <<  dataDest <<  std::endl;
      }
 
Index: XIOS/trunk/src/node/field.hpp
===================================================================
--- XIOS/trunk/src/node/field.hpp	(revision 623)
+++ XIOS/trunk/src/node/field.hpp	(revision 624)
@@ -15,5 +15,4 @@
 #include "expr_node.hpp"
 #include "declare_ref_func.hpp"
-#include "generic_filter.hpp"
 #include "transformation_enum.hpp"
 
@@ -231,5 +230,4 @@
          bool isReadDataRequestPending;
          std::vector<CField*> filterSources_;
-         std::vector<CGenericAlgorithm*> algorithms_;
          DECLARE_REF_FUNC(Field,field)
 
Index: XIOS/trunk/src/node/grid.cpp
===================================================================
--- XIOS/trunk/src/node/grid.cpp	(revision 623)
+++ XIOS/trunk/src/node/grid.cpp	(revision 624)
@@ -772,11 +772,12 @@
   bool CGrid::doGridHaveDataToWrite()
   {
-    size_t ssize = 0;
-    for (map<int, CArray<size_t, 1>* >::const_iterator it = outIndexFromClient.begin();
-                                                       it != outIndexFromClient.end(); ++it)
-    {
-      ssize += (it->second)->numElements();
-    }
-    return (0 != ssize);
+//    size_t ssize = 0;
+//    for (map<int, CArray<size_t, 1>* >::const_iterator it = outIndexFromClient.begin();
+//                                                       it != outIndexFromClient.end(); ++it)
+//    {
+//      ssize += (it->second)->numElements();
+//    }
+//    return (0 != ssize);
+     return (0 != writtenDataSize_);
   }
 
Index: XIOS/trunk/src/output/nc4_data_output.cpp
===================================================================
--- XIOS/trunk/src/output/nc4_data_output.cpp	(revision 623)
+++ XIOS/trunk/src/output/nc4_data_output.cpp	(revision 624)
@@ -1362,5 +1362,4 @@
            if (!field->prec.isEmpty() && field->prec==2) fieldData=round(fieldData) ;
 
-           std::cout << "fieldData "<< fieldData << std::endl;
            switch (SuperClass::type)
            {
Index: XIOS/trunk/src/test/test_client.f90
===================================================================
--- XIOS/trunk/src/test/test_client.f90	(revision 623)
+++ XIOS/trunk/src/test/test_client.f90	(revision 624)
@@ -88,5 +88,5 @@
   CALL xios_get_handle("output",file_hdl)
   CALL xios_add_child(file_hdl,field_hdl)
-  CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_C")
+  CALL xios_set_attr(field_hdl,field_ref="field_A_zoom",name="field_C")
 
   dtime%second = 3600
Index: XIOS/trunk/src/test/test_complete.f90
===================================================================
--- XIOS/trunk/src/test/test_complete.f90	(revision 623)
+++ XIOS/trunk/src/test/test_complete.f90	(revision 624)
@@ -96,5 +96,5 @@
   CALL xios_set_domain_attr("domain_atm_zoom",data_dim=2, data_ibegin=-1, data_ni=ni+2, data_jbegin=-2, data_nj=nj+4)
   CALL xios_set_domain_attr("domain_atm_zoom",lonvalue=RESHAPE(lon,(/ni*nj/)),latvalue=RESHAPE(lat,(/ni*nj/)))
-  CALL xios_set_domain_attr("domain_atm_zoom",zoom_ibegin=39, zoom_ni=20, zoom_jbegin=39, zoom_nj=5)
+!  CALL xios_set_domain_attr("domain_atm_zoom",zoom_ibegin=39, zoom_ni=20, zoom_jbegin=39, zoom_nj=5)
 
 !!! Activation du groupe field_definition
@@ -109,5 +109,5 @@
 !!! Heritage des attributs d un autre champ
 
-  CALL xios_set_attr(field_hdl,field_ref="field_A_atm",name="field_B_atm")
+  CALL xios_set_attr(field_hdl,field_ref="field_A_atm_zoom",name="field_B_atm")
 
 !!! Affectation de ce nouveau champ au fichier avec un nouveau nom
Index: XIOS/trunk/src/test/test_new_features.f90
===================================================================
--- XIOS/trunk/src/test/test_new_features.f90	(revision 623)
+++ XIOS/trunk/src/test/test_new_features.f90	(revision 624)
@@ -15,7 +15,7 @@
   CHARACTER(len=15) :: calendar_type
   TYPE(xios_context) :: ctx_hdl
-  INTEGER,PARAMETER :: ni_glo=5
-  INTEGER,PARAMETER :: nj_glo=5
-  INTEGER,PARAMETER :: llm=2
+  INTEGER,PARAMETER :: ni_glo=100
+  INTEGER,PARAMETER :: nj_glo=100
+  INTEGER,PARAMETER :: llm=5
   DOUBLE PRECISION  :: lval(llm)=1, tsTemp
   TYPE(xios_field) :: field_hdl
@@ -68,10 +68,10 @@
   axisBegin = 0
   nAxis = llm
-  DO n=0, size -1
-    nAxis = llm/size
-    IF (n<MOD(llm,size)) nAxis=nAxis+1
-    IF (n==rank) exit
-    axisBegin=axisBegin+nAxis
-  ENDDO
+!  DO n=0, size -1
+!    nAxis = llm/size
+!    IF (n<MOD(llm,size)) nAxis=nAxis+1
+!    IF (n==rank) exit
+!    axisBegin=axisBegin+nAxis
+!  ENDDO
   axisEnd=axisBegin+nAxis-1
 
@@ -117,11 +117,11 @@
   CALL xios_set_fieldgroup_attr("field_definition",enabled=.TRUE.)
 
-!  CALL xios_get_handle("field_definition",fieldgroup_hdl)
-!  CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B")
-!  CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_B")
-!
-!  CALL xios_get_handle("output",file_hdl)
-!  CALL xios_add_child(file_hdl,field_hdl)
-!  CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_C")
+  CALL xios_get_handle("field_definition",fieldgroup_hdl)
+  CALL xios_add_child(fieldgroup_hdl,field_hdl,"field_B")
+  CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_B")
+
+  CALL xios_get_handle("output",file_hdl)
+  CALL xios_add_child(file_hdl,field_hdl)
+  CALL xios_set_attr(field_hdl,field_ref="field_A",name="field_C")
 !
 !  CALL xios_get_handle("output_All_Axis",file_hdl)
Index: XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp	(revision 624)
+++ XIOS/trunk/src/transformation/axis_algorithm_inverse.cpp	(revision 624)
@@ -0,0 +1,43 @@
+/*!
+   \file axis_algorithm_inverse.hpp
+   \author Ha NGUYEN
+   \since 14 May 2015
+   \date 09 June 2015
+
+   \brief Algorithm for inversing an axis..
+ */
+#include "axis_algorithm_inverse.hpp"
+
+namespace xios {
+
+CAxisAlgorithmInverse::CAxisAlgorithmInverse(CAxis* axisDestination, CAxis* axisSource)
+ : CAxisAlgorithmTransformation(axisDestination, axisSource)
+{
+  if (axisDestination->size.getValue() != axisSource->size.getValue())
+  {
+    ERROR("CAxisAlgorithmInverse::CAxisAlgorithmInverse(CAxis* axisDestination, CAxis* axisSource)",
+           << "Two axis have different size"
+           << "Size of axis source " <<axisSource->getId() << " is " << axisSource->size.getValue()  << std::endl
+           << "Size of axis destionation " <<axisDestination->getId() << " is " << axisDestination->size.getValue());
+  }
+
+
+  axisDestGlobalSize_ = axisDestination->size.getValue();
+  int niDest = axisDestination->ni.getValue();
+  int ibeginDest = axisDestination->ibegin.getValue();
+
+  for (int idx = 0; idx < niDest; ++idx)
+    if ((axisDestination->mask)(idx)) axisDestGlobalIndex_.push_back(ibeginDest+idx);
+  this->computeIndexSourceMapping();
+}
+
+void CAxisAlgorithmInverse::computeIndexSourceMapping()
+{
+  std::map<int, std::vector<int> >& transMap = this->transformationMapping_;
+
+  int globalIndexSize = axisDestGlobalIndex_.size();
+  for (int idx = 0; idx < globalIndexSize; ++idx)
+    transMap[axisDestGlobalIndex_[idx]].push_back(axisDestGlobalSize_-axisDestGlobalIndex_[idx]-1);
+}
+
+}
Index: XIOS/trunk/src/transformation/axis_algorithm_inverse.hpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_inverse.hpp	(revision 624)
+++ XIOS/trunk/src/transformation/axis_algorithm_inverse.hpp	(revision 624)
@@ -0,0 +1,31 @@
+/*!
+   \file axis_algorithm_inverse.hpp
+   \author Ha NGUYEN
+   \since 14 May 2015
+   \date 09 June 2015
+
+   \brief Algorithm for inversing an axis..
+ */
+#ifndef __XIOS_AXIS_ALGORITHM_INVERSE_HPP__
+#define __XIOS_AXIS_ALGORITHM_INVERSE_HPP__
+
+#include "axis_algorithm_transformation.hpp"
+#include "axis.hpp"
+
+namespace xios {
+/*!
+  \class CAxisAlgorithmInverse
+  Inversing an axis
+*/
+class CAxisAlgorithmInverse : public CAxisAlgorithmTransformation
+{
+public:
+  CAxisAlgorithmInverse(CAxis* axisDestination, CAxis* axisSource);
+
+  virtual ~CAxisAlgorithmInverse() {}
+
+  virtual void computeIndexSourceMapping();
+};
+
+}
+#endif // __XIOS_AXIS_ALGORITHM_INVERSE_HPP__
Index: XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp	(revision 624)
+++ XIOS/trunk/src/transformation/axis_algorithm_transformation.cpp	(revision 624)
@@ -0,0 +1,149 @@
+/*!
+   \file axis_algorithm_transformation.hpp
+   \author Ha NGUYEN
+   \since 14 May 2015
+   \date 09 June 2015
+
+   \brief Interface for all axis transformation algorithms.
+ */
+
+#include "axis_algorithm_transformation.hpp"
+#include "axis_algorithm_inverse.hpp"
+#include "axis_algorithm_zoom.hpp"
+
+namespace xios {
+
+CAxisAlgorithmTransformation::CAxisAlgorithmTransformation(CAxis* axisDestination, CAxis* axisSource)
+ : CGenericAlgorithmTransformation()
+{
+}
+
+CAxisAlgorithmTransformation::~CAxisAlgorithmTransformation()
+{
+}
+
+void CAxisAlgorithmTransformation::computeIndexSourceMapping()
+{
+}
+
+/*!
+  Compute an array of global index from a global index on a axis
+  \param[in] axisDestGlobalIndex global index on an axis of destination grid
+  \param[in] axisSrcGlobalIndex global index on an axis of source grid (which are needed by one index on axis destination)
+  \param[in] axisPositionInGrid position of the axis in the grid
+  \param[in] gridDestGlobalDim dimension size of destination grid (it should share the same size for all dimension, maybe except the axis on which transformation is performed)
+  \param[in] globalIndexGridDestSendToServer global index of destination grid which are to be sent to server(s)
+  \param[in/out] globalIndexDestGrid array of global index (for 2d grid, this array is a line, for 3d, this array represents a plan). It should be preallocated
+  \param[in/out] globalIndexSrcGrid array of global index of source grid (for 2d grid, this array is a line, for 3d, this array represents a plan). It should be preallocated
+*/
+void CAxisAlgorithmTransformation::computeGlobalIndexFromGlobalIndexElement(int axisDestGlobalIndex,
+                                                                          const std::vector<int>& axisSrcGlobalIndex,
+                                                                          int axisPositionInGrid,
+                                                                          const std::vector<int>& gridDestGlobalDim,
+                                                                          const CArray<size_t,1>& globalIndexGridDestSendToServer,
+                                                                          CArray<size_t,1>& globalIndexDestGrid,
+                                                                          std::vector<CArray<size_t,1> >& globalIndexSrcGrid)
+{
+  int globalDim = gridDestGlobalDim.size();
+
+  std::vector<size_t> currentIndex(globalDim);
+  std::vector<int> gridAxisGlobalDim(globalDim);
+  std::vector<int> idxLoop(globalDim, 0);
+
+  size_t ssize = 1, idx = 0, realGlobalIndexSize = 0;
+  for (int i = 0; i< globalDim; ++i)
+  {
+    if (axisPositionInGrid == i) gridAxisGlobalDim[i] = 1;
+    else gridAxisGlobalDim[i] = gridDestGlobalDim[i];
+    ssize *= gridAxisGlobalDim[i];
+  }
+
+  CArray<size_t,1>::const_iterator itbArr = globalIndexGridDestSendToServer.begin(), itArr,
+                                   iteArr = globalIndexGridDestSendToServer.end();
+
+  while (idx < ssize)
+  {
+    for (int i = 0; i < globalDim-1; ++i)
+    {
+      if (idxLoop[i] == gridAxisGlobalDim[i])
+      {
+        idxLoop[i] = 0;
+        ++idxLoop[i+1];
+      }
+    }
+
+    for (int i = 0; i < globalDim; ++i) currentIndex[i] = idxLoop[i];
+    currentIndex[axisPositionInGrid] = axisDestGlobalIndex;
+
+    size_t globIndex = currentIndex[0];
+    size_t mulDim = 1;
+    for (int k = 1; k < globalDim; ++k)
+    {
+      mulDim *= gridDestGlobalDim[k-1];
+      globIndex += (currentIndex[k])*mulDim;
+    }
+
+    itArr = std::find(itbArr, iteArr, globIndex);
+    if (iteArr != itArr) ++realGlobalIndexSize;
+    ++idxLoop[0];
+    ++idx;
+  }
+
+  if (globalIndexDestGrid.numElements() != realGlobalIndexSize)
+    globalIndexDestGrid.resize(realGlobalIndexSize);
+
+  if (axisSrcGlobalIndex.size() != globalIndexSrcGrid.size()) globalIndexSrcGrid.resize(axisSrcGlobalIndex.size());
+  for (int i = 0; i < globalIndexSrcGrid.size(); ++i)
+    if (globalIndexSrcGrid[i].numElements() != realGlobalIndexSize)
+      globalIndexSrcGrid[i].resize(realGlobalIndexSize);
+
+
+  size_t realGlobalIndex = 0;
+  idx = 0;
+  idxLoop.assign(globalDim, 0);
+  while (idx < ssize)
+  {
+    for (int i = 0; i < globalDim-1; ++i)
+    {
+      if (idxLoop[i] == gridAxisGlobalDim[i])
+      {
+        idxLoop[i] = 0;
+        ++idxLoop[i+1];
+      }
+    }
+
+    for (int i = 0; i < globalDim; ++i) currentIndex[i] = idxLoop[i];
+    currentIndex[axisPositionInGrid] = axisDestGlobalIndex;
+
+    size_t globIndex = currentIndex[0];
+    size_t mulDim = 1;
+    for (int k = 1; k < globalDim; ++k)
+    {
+      mulDim *= gridDestGlobalDim[k-1];
+      globIndex += (currentIndex[k])*mulDim;
+    }
+
+    itArr = std::find(itbArr, iteArr, globIndex);
+    if (iteArr != itArr)
+    {
+      globalIndexDestGrid(realGlobalIndex) = globIndex;
+      for (int i = 0; i < globalIndexSrcGrid.size(); ++i)
+      {
+        currentIndex[axisPositionInGrid] = axisSrcGlobalIndex[i];
+        globIndex = currentIndex[0];
+        mulDim = 1;
+        for (int k = 1; k < globalDim; ++k)
+        {
+          mulDim *= gridDestGlobalDim[k-1];
+          globIndex += (currentIndex[k])*mulDim;
+        }
+        (globalIndexSrcGrid[i])(realGlobalIndex) = globIndex;
+      }
+      ++realGlobalIndex;
+    }
+
+    ++idxLoop[0];
+    ++idx;
+  }
+}
+}
Index: XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp	(revision 624)
+++ XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp	(revision 624)
@@ -0,0 +1,48 @@
+/*!
+   \file axis_algorithm_transformation.hpp
+   \author Ha NGUYEN
+   \since 14 May 2015
+   \date 09 June 2015
+
+   \brief Interface for all axis transformation algorithms.
+ */
+#ifndef __XIOS_AXIS_ALGORITHM_TRANSFORMATION_HPP__
+#define __XIOS_AXIS_ALGORITHM_TRANSFORMATION_HPP__
+
+#include "generic_algorithm_transformation.hpp"
+#include "axis.hpp"
+
+namespace xios {
+
+/*!
+  \class CAxisAlgorithmTransformation
+  Algorithms for axis.
+*/
+class CAxisAlgorithmTransformation : public virtual CGenericAlgorithmTransformation
+{
+public:
+  CAxisAlgorithmTransformation(CAxis* axisDestination, CAxis* axisSource);
+
+  virtual ~CAxisAlgorithmTransformation();
+
+protected:
+  virtual void computeGlobalIndexFromGlobalIndexElement(int axisDestGlobalIndex,
+                                                        const std::vector<int>& axisSrcGlobalIndex,
+                                                        int axisPositionInGrid,
+                                                        const std::vector<int>& gridDestGlobalDim,
+                                                        const CArray<size_t,1>& globalIndexGridDestSendToServer,
+                                                        CArray<size_t,1>& globalIndexDestGrid,
+                                                        std::vector<CArray<size_t,1> >& globalIndexSrcGrid);
+  void computeIndexSourceMapping();
+
+protected:
+  //! Global index of an axis on grid destination
+  std::vector<int> axisDestGlobalIndex_;
+
+  //! Size of
+  int axisDestGlobalSize_;
+
+};
+
+}
+#endif // __XIOS_AXIS_ALGORITHM_TRANSFORMATION_HPP__
Index: XIOS/trunk/src/transformation/axis_algorithm_zoom.cpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_zoom.cpp	(revision 624)
+++ XIOS/trunk/src/transformation/axis_algorithm_zoom.cpp	(revision 624)
@@ -0,0 +1,85 @@
+/*!
+   \file axis_algorithm_zoom.cpp
+   \author Ha NGUYEN
+   \since 03 June 2015
+   \date 12 June 2015
+
+   \brief Algorithm for zooming on an axis.
+ */
+#include "axis_algorithm_zoom.hpp"
+
+namespace xios {
+
+CAxisAlgorithmZoom::CAxisAlgorithmZoom(CAxis* axisDestination, CAxis* axisSource, CZoomAxis* zoomAxis)
+: CAxisAlgorithmTransformation(axisDestination, axisSource), axisDest_(axisDestination), axisSrc_(axisSource)
+{
+  zoomAxis->checkValid(axisSource);
+  zoomBegin_ = zoomAxis->zoom_begin.getValue();
+  zoomEnd_   = zoomAxis->zoom_end.getValue();
+  zoomSize_  = zoomAxis->zoom_size.getValue();
+
+  if (zoomSize_ > axisSource->size.getValue())
+  {
+    ERROR("CAxisAlgorithmZoom::CAxisAlgorithmZoom(CAxis* axisDestination, CAxis* axisSource, CZoomAxis* zoomAxis)",
+           << "Zoom size is greater than size of axis source"
+           << "Size of axis source " <<axisSource->getId() << " is " << axisSource->size.getValue()  << std::endl
+           << "Zoom size is " << zoomSize_ );
+  }
+
+  computeIndexSourceMapping();
+}
+
+/*!
+  Compute the index mapping between axis on grid source and one on grid destination
+*/
+void CAxisAlgorithmZoom::computeIndexSourceMapping()
+{
+  StdSize niSource = axisSrc_->ni.getValue();
+  StdSize ibeginSource = axisSrc_->ibegin.getValue();
+  StdSize iendSource = ibeginSource + niSource - 1;
+
+  StdSize ibegin = std::max(ibeginSource, zoomBegin_);
+  StdSize iend = std::min(iendSource, zoomEnd_);
+  StdSize ni = iend + 1 - ibegin;
+  if (iend < ibegin) ni = 0;
+
+  std::map<int, std::vector<int> >& transMap = this->transformationMapping_;
+  for (StdSize idx = 0; idx < ni; ++idx)
+  {
+    transMap[ibegin+idx].push_back(ibegin+idx);
+  }
+
+  updateZoom();
+  updateAxisDestinationMask();
+}
+
+/*!
+  After a zoom on axis, it should be certain that (global) zoom begin and (global) zoom size are updated
+*/
+void CAxisAlgorithmZoom::updateZoom()
+{
+  axisDest_->global_zoom_begin = zoomBegin_;
+  axisDest_->global_zoom_size  = zoomSize_;
+}
+
+/*!
+  Update mask on axis
+  Because only zoomed region on axis is not masked, the remaining must be masked to make sure
+correct index be extracted
+*/
+void CAxisAlgorithmZoom::updateAxisDestinationMask()
+{
+  StdSize niMask = axisDest_->mask.numElements();
+  StdSize iBeginMask = axisDest_->ibegin.getValue();
+  StdSize globalIndexMask = 0;
+  std::map<int, std::vector<int> >& transMap = this->transformationMapping_;
+  std::map<int, std::vector<int> >::const_iterator ite = (transMap).end();
+  for (StdSize idx = 0; idx < niMask; ++idx)
+  {
+    globalIndexMask = iBeginMask + idx;
+    if (transMap.find(globalIndexMask) == ite)
+      (axisDest_->mask)(idx) = false;
+  }
+}
+
+}
Index: XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp
===================================================================
--- XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp	(revision 624)
+++ XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp	(revision 624)
@@ -0,0 +1,55 @@
+/*!
+   \file axis_algorithm_zoom.hpp
+   \author Ha NGUYEN
+   \since 03 June 2015
+   \date 12 June 2015
+
+   \brief Algorithm for zooming on an axis.
+ */
+#ifndef __XIOS_AXIS_ALGORITHM_ZOOM_HPP__
+#define __XIOS_AXIS_ALGORITHM_ZOOM_HPP__
+
+#include "axis_algorithm_transformation.hpp"
+#include "axis.hpp"
+#include "zoom_axis.hpp"
+
+namespace xios {
+/*!
+  \class CAxisAlgorithmZoom
+  Implementing zoom on axis
+  A zoomed region can be considered as region that isnt masked.
+  Only this zoomed region is extracted to write on Netcdf.
+*/
+class CAxisAlgorithmZoom : public CAxisAlgorithmTransformation
+{
+public:
+  CAxisAlgorithmZoom(CAxis* axisDestination, CAxis* axisSource, CZoomAxis* zoomAxis);
+
+  virtual ~CAxisAlgorithmZoom() {}
+
+  virtual void computeIndexSourceMapping();
+
+private:
+  void updateAxisDestinationMask();
+  void updateZoom();
+
+private:
+  //! Global zoom begin on axis
+  StdSize zoomBegin_;
+
+  //! Global zoom end on axis
+  StdSize zoomEnd_;
+
+  //! Global zoom size on axis
+  StdSize zoomSize_;
+
+private:
+  //! Axis on grid destination
+  CAxis* axisDest_;
+
+  //! Axis on grid source
+  CAxis* axisSrc_;
+};
+
+}
+#endif // __XIOS_AXIS_ALGORITHM_ZOOM_HPP__
